note
	description: "Summary description for {STATISTICS}."
	author: "Jonathan S. Ostroff and Jackie Wang"
	date: "$Date$"
	revision: "$Revision$"

class
	STATISTICS
inherit
	OBSERVER
create
	make

feature {NONE} --creation
	make(wd: WEATHER_DATA)
		do
			weather_data := wd
			min_temp := 15
			max_temp := 5
			wd.attach (Current)
		end

feature -- Attributes
	weather_data: WEATHER_DATA
	current_temp: REAL
	max_temp: REAL
	min_temp: REAL
	sum_so_far: REAL
	num_readings: INTEGER

	up_to_date_with_subject: BOOLEAN
			-- is this observer up to date with its subject
		do
			if  current_temp = weather_data.temperature then
				Result := true
			end
		end

	update
			-- update the observer's view of `s'
		do
			current_temp := weather_data.temperature
			num_readings := num_readings + 1
      		sum_so_far := sum_so_far + current_temp
      		if current_temp > max_temp then
        		max_temp := current_temp
      		end
      		if  current_temp < min_temp then
        		min_temp := current_temp
      		end
			display
		end

	display
		do
			print("Avg/Max/Min temperature = ")
			print(sum_so_far / num_readings)
			print("/")
			print(max_temp)
			print("/")
			print(min_temp)
			print("%N")
		end

end
